VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ScanDisk"
   ClientHeight    =   3045
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   ScaleHeight     =   3045
   ScaleWidth      =   4935
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "C:\"
      Top             =   360
      Width           =   3135
   End
   Begin VB.ListBox Loglist 
      Height          =   1815
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   4695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Scan"
      Height          =   495
      Left            =   3360
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin VB.Label Status 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "Ready"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   2760
      Width           =   4935
   End
   Begin VB.Label Label1 
      Caption         =   "Whlen Sie bitte das Verzeichnis aus:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const LogFile As String = "scandisk.log"

Dim Dateien() As String

Dim minWidth As Double
Dim maxWidth As Double
Dim minHeight As Double
Dim maxHeight As Double

Dim Verz As String

Private Sub Command1_Click()
 If Command1.Caption = "Scan" Then
  Command1.Caption = "Cancel"
  Command1.Tag = ""
  
  Loglist_Add "Start"
  ReDim Dateien(0) As String
  Loglist_Add "Durchsuche Verzeichnis..."
  DirFiles Text1.Text
  If Command1.Tag = "1" Then GoTo Ende
  Loglist_Add "Lese Dateien..."
  Dim X As Long
  Dim FileNum%
  FileNum% = FreeFile
  Dim Stelle As Long
  Dim Temp As String
  For X = 1 To UBound(Dateien)
   Status = "ffne '" + Dateien(X) + "'"
   DoEvents
   If Command1.Tag = "1" Then GoTo Ende
   On Error GoTo Fehler_ffnen
   Open Dateien(X) For Binary Access Read As FileNum%
   On Error GoTo Fehler_Lesen
   Stelle = 1
   Do While Not Stelle > LOF(FileNum%)
    If Stelle + 100000 <= LOF(FileNum%) + 1 Then '100 KB
     Temp = Space$(100000)
    Else
     Temp = Space$(LOF(FileNum%) - Stelle + 1)
    End If
    Get #FileNum%, Stelle, Temp
    Stelle = Stelle + Len(Temp)
    Status = "Lese " + LTrim$(RTrim$(Str$(Int(((Stelle - 1) / LOF(FileNum%)) * 100)))) + "% '" + Dateien(X) + "'"
    DoEvents
    If Command1.Tag = "1" Then
     Close FileNum%
     GoTo Ende
    End If
   Loop
   Close FileNum%
NextFile:
  Next
Ende:
  Loglist_Add "Ende"
  Status = "Ready"
  Command1.Caption = "Scan"
  Exit Sub
 Else
  Loglist_Add "Abbruch"
  Command1.Tag = "1"
 End If
 Exit Sub
 
Fehler_ffnen:
 Loglist_Add "Fehler beim ffnen der Datei '" + Dateien(X) + "': (" + LTrim$(RTrim$(Str$(Err.Number))) + ") " + Err.Description
 Resume NextFile
Fehler_Lesen:
 Loglist_Add "Fehler beim Lesen der Datei '" + Dateien(X) + "': (" + LTrim$(RTrim$(Str$(Err.Number))) + ") " + Err.Description
 Status = "Fehler"
 Close FileNum%
 Resume NextFile

End Sub

Sub Loglist_Add(ByVal Text As String)
 Loglist.AddItem Text
 Loglist.ListIndex = Loglist.ListCount - 1
 
 If LogFile <> "" Then
  Dim FileNum%
  FileNum% = FreeFile
  Open Verz + LogFile For Append As FileNum%
  Print #FileNum%, Text
  Close FileNum%
 End If
End Sub

Sub DirFiles(ByVal TheDir As String)
 On Error GoTo Fehler_Durchsuchen
 Status = "Scan '" + TheDir + "'"
 Dim Verzeichnisse() As String
 ReDim Verzeichnisse(0) As String
 Dim Temp As String
 If Not Right$(TheDir, 1) = "\" Then TheDir = TheDir + "\"
 Temp = Dir$(TheDir + "*.*", vbNormal + vbHidden + vbReadOnly + vbSystem + vbDirectory)
 Do While Not Temp = ""
  If Left$(Temp, 1) = "." Then GoTo Weiter
  On Error GoTo CannotRead
  If GetAttr(TheDir + Temp) And vbDirectory Then
   On Error GoTo Fehler_Durchsuchen
   Status = "NewDir '" + TheDir + Temp + "'"
   ReDim Preserve Verzeichnisse(UBound(Verzeichnisse) + 1) As String
   Verzeichnisse(UBound(Verzeichnisse)) = Temp
  Else
   On Error GoTo Fehler_Durchsuchen
   Status = "NewFile '" + TheDir + Temp + "'"
   ReDim Preserve Dateien(UBound(Dateien) + 1) As String
   Dateien(UBound(Dateien)) = TheDir + Temp
  End If
Weiter:
  DoEvents
  If Command1.Tag = "1" Then Exit Sub
  Temp = Dir$()
 Loop
 
 Dim X As Integer
 For X = 1 To UBound(Verzeichnisse)
  DirFiles TheDir + Verzeichnisse(X)
  If Command1.Tag = "1" Then Exit Sub
 Next
 
 Exit Sub
CannotRead:
 Loglist_Add "Kann Dateiattribute nicht lesen von '" + TheDir + Temp + "'"
 Resume Weiter
Fehler_Durchsuchen:
 Loglist_Add "Fehler beim Durchsuchen von '" + TheDir + "': (" + LTrim$(RTrim$(Str$(Err.Number))) + ") " + Err.Description
 Resume Next

End Sub

Private Sub Form_Load()
 Verz = App.Path
 If Not Right$(Verz, 1) = "\" Then Verz = Verz + "\"
 
 minWidth = Form1.Width
 maxWidth = Screen.Width * 2
 minHeight = Form1.Height
 maxHeight = Screen.Height * 2
End Sub

Private Sub Form_Resize()
 If Form1.WindowState = 1 Then Exit Sub
 If Form1.WindowState = 2 Then
  If (Form1.Width < minWidth) _
  Or (Form1.Width > maxWidth) _
  Or (Form1.Height < minHeight) _
  Or (Form1.Height > maxHeight) Then
   Form1.WindowState = 0
   Form1.Width = maxWidth
   Form1.Height = maxHeight
  End If
 End If
 If (Form1.Width < minWidth) Then Form1.Width = minWidth
 If (Form1.Width > maxWidth) Then Form1.Width = maxWidth
 If (Form1.Height < minHeight) Then Form1.Height = minHeight
 If (Form1.Height > maxHeight) Then Form1.Height = maxHeight
 
 Status.Width = Form1.ScaleWidth
 Status.Top = Form1.ScaleHeight - Status.Height
 Label1.Width = (Form1.ScaleWidth - 360) * (2 / 3)
 Text1.Width = Label1.Width
 Command1.Left = Label1.Width + 240
 Command1.Width = Label1.Width / 2
 Loglist.Top = Command1.Height + 360
 Loglist.Width = Form1.ScaleWidth - 240
 Loglist.Height = Form1.ScaleHeight - Loglist.Top - Status.Height - 120
End Sub

Private Sub Form_Unload(Cancel As Integer)
 End
End Sub
